const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const api_clients = sequelize.define(
    'api_clients',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

client_key: {
        type: DataTypes.TEXT,
      
      

      },

client_secret_hash: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"active",


"revoked"

        ],

      },

last_used_at: {
        type: DataTypes.DATE,
      
      

      },

allowed_ips: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  api_clients.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






















    db.api_clients.hasMany(db.api_tokens, {
      as: 'api_tokens_api_client',
      foreignKey: {
          name: 'api_clientId',
      },
      constraints: false,
    });









//end loop



    db.api_clients.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.api_clients.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.api_clients.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.api_clients.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return api_clients;
};


